'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _JSONArrow = require('./JSONArrow');

var _JSONArrow2 = _interopRequireDefault(_JSONArrow);

var _getCollectionEntries = require('./utils/getCollectionEntries');

var _getCollectionEntries2 = _interopRequireDefault(_getCollectionEntries);

var _JSONNode = require('./JSONNode');

var _JSONNode2 = _interopRequireDefault(_JSONNode);

var _ItemRange = require('./ItemRange');

var _ItemRange2 = _interopRequireDefault(_ItemRange);

var _createItemPreviewText = require('./utils/createItemPreviewText');

var _createItemPreviewText2 = _interopRequireDefault(_createItemPreviewText);

var _createItemTypeText = require('./utils/createItemTypeText');

var _createItemTypeText2 = _interopRequireDefault(_createItemTypeText);

var _isExpandable = require('./utils/isExpandable');

var _isExpandable2 = _interopRequireDefault(_isExpandable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Renders nested values (eg. objects, arrays, lists, etc.)
 */

function _renderChildNodes(props, from, to) {
  var nodeType = props.nodeType,
      value = props.value,
      collectionLimit = props.collectionLimit,
      circularCache = props.circularCache,
      keyPath = props.keyPath,
      postprocessValue = props.postprocessValue,
      sortObjectKeys = props.sortObjectKeys,
      styling = props.styling,
      isCustomNode = props.isCustomNode,
      renderItemPreview = props.renderItemPreview,
      renderLabel = props.renderLabel,
      renderValue = props.renderValue,
      shouldExpandNode = props.shouldExpandNode,
      level = props.level;

  var childNodes = [];

  var collectionEntries = (0, _getCollectionEntries2.default)(nodeType, value, sortObjectKeys, collectionLimit, from, to);

  collectionEntries.forEach(function (entry) {
    if (entry.isRange) {
      childNodes.push(_react2.default.createElement(_ItemRange2.default, (0, _extends3.default)({
        styling: styling,
        nodeType: nodeType
      }, {
        key: 'ItemRange--' + entry.from + '-' + entry.to,
        from: entry.from,
        to: entry.to,
        renderChildNodes: function renderChildNodes(from, to) {
          return _renderChildNodes(props, from, to);
        }
      })));
    } else {
      var key = entry.key,
          _value = entry.value;

      var _isCircular = circularCache.indexOf(_value) !== -1;

      var node = _react2.default.createElement(_JSONNode2.default, (0, _extends3.default)({
        styling: styling,
        postprocessValue: postprocessValue,
        collectionLimit: collectionLimit,
        isCustomNode: isCustomNode,
        renderItemPreview: renderItemPreview,
        renderLabel: renderLabel,
        isCircular: _isCircular,
        renderValue: renderValue,
        shouldExpandNode: shouldExpandNode,
        sortObjectKeys: sortObjectKeys,
        level: level
      }, {
        key: 'Node--' + key,
        keyPath: [key].concat((0, _toConsumableArray3.default)(keyPath)),
        value: postprocessValue(_value),
        circularCache: [].concat((0, _toConsumableArray3.default)(circularCache), [_value]),
        hideRoot: false
      }));

      if (node !== false) {
        childNodes.push(node);
      }
    }
  });

  return childNodes;
}

function getStateFromProps(props) {
  // calculate individual node expansion if necessary
  var expanded = props.shouldExpandNode && !props.isCircular ? props.shouldExpandNode(props.keyPath, props.value, props.level) : false;
  return {
    expanded: expanded
  };
}

var JSONNestedNode = function (_React$Component) {
  (0, _inherits3.default)(JSONNestedNode, _React$Component);

  function JSONNestedNode(props) {
    (0, _classCallCheck3.default)(this, JSONNestedNode);

    var _this = (0, _possibleConstructorReturn3.default)(this, (JSONNestedNode.__proto__ || (0, _getPrototypeOf2.default)(JSONNestedNode)).call(this, props));

    _this.handleClick = function () {
      return _this.setState({ expanded: !_this.state.expanded });
    };

    _this.state = getStateFromProps(props);
    return _this;
  }

  (0, _createClass3.default)(JSONNestedNode, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextState = getStateFromProps(nextProps);
      if (getStateFromProps(this.props).expanded !== nextState.expanded) {
        this.setState(nextState);
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _this2 = this;

      return !!(0, _keys2.default)(nextProps).find(function (key) {
        return key !== 'circularCache' && (key === 'keyPath' ? nextProps[key].join('/') !== _this2.props[key].join('/') : nextProps[key] !== _this2.props[key]);
      }) || nextState.expanded !== this.state.expanded;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          renderItemPreview = _props.renderItemPreview,
          nodeType = _props.nodeType,
          value = _props.value,
          hideRoot = _props.hideRoot,
          styling = _props.styling,
          collectionLimit = _props.collectionLimit,
          keyPath = _props.keyPath,
          renderLabel = _props.renderLabel,
          level = _props.level;
      var expanded = this.state.expanded;

      var renderedChildren = expanded || hideRoot && level === 0 ? _renderChildNodes((0, _extends3.default)({}, this.props, { level: level + 1 })) : null;

      var itemTypeText = (0, _createItemTypeText2.default)(nodeType);
      var itemPreviewText = (0, _createItemPreviewText2.default)(nodeType, value, collectionLimit);
      var renderedItemPreview = renderItemPreview(nodeType, value, itemTypeText, itemPreviewText);
      var expandable = (0, _isExpandable2.default)(nodeType, value);
      var stylingArgs = [keyPath, nodeType, expanded, expandable];

      return hideRoot ? _react2.default.createElement(
        'li',
        styling.apply(undefined, [['rootNode', 'rootNodeColor']].concat(stylingArgs)),
        _react2.default.createElement(
          'ul',
          styling.apply(undefined, [['rootNodeChildren', 'rootNodeChildrenColor']].concat(stylingArgs)),
          renderedChildren
        )
      ) : _react2.default.createElement(
        'li',
        styling.apply(undefined, [['nestedNode', 'nestedNodeColor']].concat(stylingArgs)),
        expandable && _react2.default.createElement(_JSONArrow2.default, {
          arrowStyle: 'single',
          styling: styling,
          nodeType: nodeType,
          expanded: expanded,
          onClick: this.handleClick
        }),
        _react2.default.createElement(
          'label',
          (0, _extends3.default)({}, styling.apply(undefined, [['label', 'labelColor', 'nestedNodeLabel', 'nestedNodeLabelColor']].concat(stylingArgs)), {
            onClick: expandable && this.handleClick
          }),
          renderLabel.apply(undefined, stylingArgs)
        ),
        _react2.default.createElement(
          'span',
          (0, _extends3.default)({}, styling.apply(undefined, [['nestedNodeItemPreview', 'nestedNodeItemPreviewColor']].concat(stylingArgs)), {
            onClick: expandable && this.handleClick
          }),
          renderedItemPreview
        ),
        _react2.default.createElement(
          'ul',
          styling.apply(undefined, [['nestedNodeChildren', 'nestedNodeChildrenColor']].concat(stylingArgs)),
          renderedChildren
        )
      );
    }
  }]);
  return JSONNestedNode;
}(_react2.default.Component);

JSONNestedNode.defaultProps = {
  circularCache: []
};
exports.default = JSONNestedNode;