'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objType = require('./utils/objType');

var _objType2 = _interopRequireDefault(_objType);

var _JSONValueNode = require('./JSONValueNode');

var _JSONValueNode2 = _interopRequireDefault(_JSONValueNode);

var _JSONNestedNode = require('./JSONNestedNode');

var _JSONNestedNode2 = _interopRequireDefault(_JSONNestedNode);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JSONNode = function JSONNode(_ref) {
  var renderItemPreview = _ref.renderItemPreview,
      keyPath = _ref.keyPath,
      renderLabel = _ref.renderLabel,
      styling = _ref.styling,
      value = _ref.value,
      renderValue = _ref.renderValue,
      isCustomNode = _ref.isCustomNode,
      hideRoot = _ref.hideRoot,
      isCircular = _ref.isCircular,
      shouldExpandNode = _ref.shouldExpandNode,
      sortObjectKeys = _ref.sortObjectKeys,
      postprocessValue = _ref.postprocessValue,
      level = _ref.level,
      collectionLimit = _ref.collectionLimit;

  var nodeType = isCustomNode(value) ? 'Custom' : (0, _objType2.default)(value);

  var valueNodeProps = {
    renderItemPreview: renderItemPreview,
    key: keyPath[0],
    keyPath: keyPath,
    renderLabel: renderLabel,
    nodeType: nodeType,
    styling: styling,
    value: value,
    renderValue: renderValue
  };

  var nestedNodeProps = (0, _extends3.default)({}, valueNodeProps, {
    value: value,
    isCustomNode: isCustomNode,
    hideRoot: hideRoot,
    isCircular: isCircular,
    shouldExpandNode: shouldExpandNode,
    sortObjectKeys: sortObjectKeys,
    postprocessValue: postprocessValue,
    level: level,
    collectionLimit: collectionLimit
  });

  switch (nodeType) {
    case 'Object':
    case 'Error':
    case 'WeakMap':
    case 'WeakSet':
    case 'Array':
    case 'Iterable':
    case 'Map':
    case 'Set':
      return _react2.default.createElement(_JSONNestedNode2.default, nestedNodeProps);
    default:
      return _react2.default.createElement(_JSONValueNode2.default, valueNodeProps);
  }
};

exports.default = JSONNode;