'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _JSONNode = require('./JSONNode');

var _JSONNode2 = _interopRequireDefault(_JSONNode);

var _createStylingFromTheme = require('./utils/createStylingFromTheme');

var _createStylingFromTheme2 = _interopRequireDefault(_createStylingFromTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var identity = function identity(value) {
  return value;
};

// ES6 + inline style port of JSONViewer https://bitbucket.org/davevedder/react-json-viewer/
// all credits and original code to the author
// Dave Vedder <veddermatic@gmail.com> http://www.eskimospy.com/
// port by Daniele Zannotti http://www.github.com/dzannotti <dzannotti@me.com>

var expandRootNode = function expandRootNode(keyName, data, level) {
  return level === 0;
};
var defaultRenderItemPreview = function defaultRenderItemPreview(type, data, itemType, itemString) {
  return _react2.default.createElement(
    'span',
    null,
    itemType,
    itemString ? ' · ' + itemString : ''
  );
};
var defaultRenderLabel = function defaultRenderLabel(_ref) {
  var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
      label = _ref2[0];

  return _react2.default.createElement(
    'span',
    null,
    label,
    ':'
  );
};
var noCustomNode = function noCustomNode() {
  return false;
};

function getStateFromProps(props) {
  return {
    styling: (0, _createStylingFromTheme2.default)(props.theme)
  };
}

var JSONTree = function (_React$Component) {
  (0, _inherits3.default)(JSONTree, _React$Component);

  function JSONTree(props) {
    (0, _classCallCheck3.default)(this, JSONTree);

    var _this = (0, _possibleConstructorReturn3.default)(this, (JSONTree.__proto__ || (0, _getPrototypeOf2.default)(JSONTree)).call(this, props));

    _this.state = getStateFromProps(props);
    return _this;
  }

  (0, _createClass3.default)(JSONTree, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;

      if (['theme'].find(function (k) {
        return nextProps[k] !== _this2.props[k];
      })) {
        this.setState(getStateFromProps(nextProps));
      }
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      var _this3 = this;

      return !!(0, _keys2.default)(nextProps).find(function (k) {
        return k === 'keyPath' ? nextProps[k].join('/') !== _this3.props[k].join('/') : nextProps[k] !== _this3.props[k];
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.data,
          keyPath = _props.keyPath,
          postprocessValue = _props.postprocessValue,
          hideRoot = _props.hideRoot,
          children = _props.children,
          isCustomNode = _props.isCustomNode,
          shouldExpandNode = _props.shouldExpandNode,
          sortObjectKeys = _props.sortObjectKeys,
          collectionLimit = _props.collectionLimit;
      var styling = this.state.styling;


      return _react2.default.createElement(
        'ul',
        styling(['tree', 'treeColor']),
        _react2.default.createElement(_JSONNode2.default, (0, _extends3.default)({
          postprocessValue: postprocessValue,
          hideRoot: hideRoot,
          styling: styling,
          isCustomNode: isCustomNode,
          shouldExpandNode: shouldExpandNode,
          sortObjectKeys: sortObjectKeys,
          collectionLimit: collectionLimit
        }, {
          level: 0,
          renderItemPreview: children.renderItemPreview || defaultRenderItemPreview,
          renderLabel: children.renderLabel || defaultRenderLabel,
          renderValue: children.renderValue || identity,
          keyPath: hideRoot ? [] : keyPath,
          value: postprocessValue(value)
        }))
      );
    }
  }]);
  return JSONTree;
}(_react2.default.Component);

JSONTree.defaultProps = {
  shouldExpandNode: expandRootNode,
  hideRoot: false,
  keyPath: ['root'],
  postprocessValue: identity,
  isCustomNode: noCustomNode,
  collectionLimit: 50,
  children: {}
};
exports.default = JSONTree;