'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _isSafeInteger = require('babel-runtime/core-js/number/is-safe-integer');

var _isSafeInteger2 = _interopRequireDefault(_isSafeInteger);

var _getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names');

var _getOwnPropertyNames2 = _interopRequireDefault(_getOwnPropertyNames);

exports.default = createItemPreviewText;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createObjectPreviewText(data) {
  var len = (0, _getOwnPropertyNames2.default)(data).length;
  return len + ' ' + (len !== 1 ? 'keys' : 'key');
}


function createArrayPrevew(data) {
  return data.length + ' ' + (data.length !== 1 ? 'items' : 'item');
}

function createIterablePreviewText(data, limit) {
  var count = 0;
  var hasMore = false;
  if ((0, _isSafeInteger2.default)(data.size)) {
    count = data.size;
  } else {
    // eslint-disable-next-line no-unused-vars
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = (0, _getIterator3.default)(data), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var entry = _step.value;

        if (limit && count + 1 > limit) {
          hasMore = true;
          break;
        }
        count += 1;
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }
  return '' + (hasMore ? '>' : '') + count + ' ' + (count !== 1 ? 'entries' : 'entry');
}

function createItemPreviewText(nodeType, data, limit) {
  switch (nodeType) {
    case 'WeakMap':
    case 'WeakSet':
      return '';
    case 'Array':
      return createArrayPrevew(data);
    case 'Iterable':
    case 'Map':
    case 'Set':
      return createIterablePreviewText(data, limit);
    default:
      return createObjectPreviewText(data);
  }
}